<?php
/**
 * NAVT Word Press Plugin
 * Copyright (c) 2006-2007 Greg A. Bellucci/Atalaya Studio
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
 * LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * @package NAVT Word Press Plugin
 * @author Greg A. Bellucci <greg[AT]gbellucci[DOT]us
 * @copyright Copyright &copy; 2006-2007 Greg A. Bellucci
 * @license http://www.opensource.org/licenses/mit-license.php The MIT License
 */
require (dirname(__FILE__).'/../../../../wp-config.php');

if( isset($_GET['tipid']) ) {

    $tipnum = $_GET['tipid'];
    $blank_img = NAVT::get_url() . '/' . IMG_BLANK;
    $avatar_url = NAVT::get_url() . '/avatars';
    $tip = "";

    $closer = "<li><input type='button' value='".__('Close')."' class='cbutton closer' /></li>";
    $anchor_options =
    "<h4>".__('Anchor Display Options')."</h4><p>".__('This option allows you to select the way you\'d like to display this link in your navigation.') ."</p><dl><dt>".__('Standard Link')."</dt><dd>".__('An ordinary anchor composed of the menu alias')."</dd><dd class='exmp'>".__('Example:')."</dd><div class='ex_wrapper'><a href='#'>".__('Menu Alias')."</a></div><dt>".__('Text over Graphic')."</dt><dd>".__('This link is constructed by placing the menu alias on top of a graphic background. NAVT will assign several classes to this item making it possible for you to choose one of the assigned classes and define a background image to be used.')."</dd><dd class='exmp'>".__('Example:')."</dd><div class='ex_wrapper'><a title='".__('Menu Alias')."' href='#' class='extog'>".__('Menu Alias')."</a></div><dt>".__('Text with Side Graphic')."</dt><dd>".__('This link separates the anchor text from the graphic. The graphic will appear on the left and the anchor text to the right. CSS classes and absolute positioning can make it possible for you to change the way the link is displayed (graphic on the right with link text on the left). The CSS controls the height and width of the graphic, the spacing and the position of the anchor text.')."</dd><dd>".__('The textbox below the Anchor Display Options (<em>Image class for side graphic</em>) is used to indicate the name of the CSS class to be attached to your side graphic. This class is expected to contain the background image you want displayed next to the anchor text. The plugin uses a transparent graphic to create the necessary anchor space enabling you to control the background image by simply supplying the associated CSS class you want to use. The width and height of the graphic is controlled by your CSS image class definition.')."</dd><dd class='exmp'>".__('Example:')."</dd> <div class='extsg'><a title='".__('Menu Alias')."' class='aextsg' href='#'><img alt='".__('Menu Alias')."' src='". $blank_img . "' class='sgraphic' /><span class='stext'>".__('Menu Alias')."</span></a></div><dt>".__('Graphic Link')."</dt><dd>".__('Graphic only links are links that do not display the menu alias. The menu text will appear in the HTML, however, inline styling forces the text off the page and out of the viewer\'s sight. This technique makes it possible for robots and web crawlers to continue to see the link text.')."</dd><dd class='exmp'>".__('Example:')."</dd><div class='dgraphix' ><a title='".__('Menu Alias')."' class='agraphix' href='#'><img alt='".__('Menu Alias')."' src='" . $blank_img . "' class='igraphix' /><span>".__('menu alias')."</span></a></div></dl>";

    $menu_alias =
    "<h4>".__('Menu Alias')."</h4><p>".__('The name or title of the navigation item that appears in your top navigation bar or sidebar may be too long to fit in the space available; this is the reason for the menu alias. The alias defaults to the page title, category title or user name, however, you can change the name that appears by entering a different value in the alias menu textbox. Changing the menu alias does not modify the page title or category title you\'ve given it. Nor will changing the page title or category name change the menu alias.')."</p>";

    $private_option =
    "<h4>".__('Private option')."</h4><p>".__('Selecting this option makes it possible to hide this page from casual viewers. User\'s must be logged into your site to see this link in your navigation.')."</p>";

    $do_not_use_option =
    "<h4>".__('Do not use')."</h4><p>".__('If you do not intend to use this navigation item in any group then it can be hidden until you are ready to use it. Hiding the item cuts down on the number of items on this page. You can restore all hidden items by selecting <strong>Restore Hidden items</strong> in the Group Options menu at the top of the navigation group where the item was originally hidden. Alternatively, go to Manage Page or Manage Categories and edit the item then uncheck the <strong>Do not use</strong> checkbox.')."</p>";

    $relnofollow =
    "<h4>".__('rel=nofollow')."</h4><p>".__('Select this checkbox to prevent Internet robots or Web Spiders from following this internal link')."</p>";

    switch( $tipnum ) {

        case TYPE_PAGE: {
            $heading = "<h3>Options for Pages</h3>";
            $tip ="<div class='tiplinks'><ul>" . $closer . "<li><input id='b1' type='button' value='1' class='pbutton p1 disable' disabled='disabled' /></li><li><input id='b2' type='button' value='2' class='pbutton p2' /></li></ul></div><div id='tippage1' class='tippage viewing'>" . $heading . $anchor_options . "</div><div id='tippage2' class='tippage' style='display:none;'>" . $heading . $menu_alias . $private_option . $relnofollow . $do_not_use_option . "</div>";
            break;
        }

        case TYPE_CAT: {
            $heading = "<h3>".__('Options for Categories')."</h3>";
            $tip ="<div class='tiplinks'><ul>" . $closer . "<li><input id='b1' type='button' value='1' class='pbutton p1 disable' disabled='disabled' /></li><li><input id='b2' type='button' value='2' class='pbutton p2' /></li><li><input id='b3' type='button' value='3' class='pbutton p3' /></li></ul></div><div id='tippage1' class='tippage viewing'>" . $heading . "<h4>".__('Show Category in Word Press Category List')."</h4><p>".__('NAVT always excludes a category that is part of a navigation list from being displayed by the native Word Press category list functions. This is because a navigation item appearing in more than one location on a page can sometimes be confusing. Checking this box will prevent NAVT from filtering the category allowing it to appear in both your navigaiton list and in a Word Press category list.')."</p><h4>".__('Append Post Count')."</h4><p>".__('This option will cause the plugin to add the current post count to the end of a text link. The post count can be styled independently of the text in the anchor')."</p><h4>".__('Show If Empty')."</h4><p>".__('By default the plugin will not show categories that do not contain posts. Usually, clicking an empty category will cause a 404 (file not found) error to occur. You can force the plugin to show the category (even when empty) by checking this option.')."</p><h4>".__('Use the Category Description as the tooltip')."</h4><p>".__('This option causes the category discription to be displayed when the mouse hovers over the text anchor')."</p></div><div id='tippage2' class='tippage' style='display:none;'>" . $heading . $anchor_options . "</div><div id='tippage3' class='tippage' style='display:none;'>" . $heading . $menu_alias . $private_option . $relnofollow . $do_not_use_option . "</div>";
            break;
        }

        case TYPE_LINK: {
            $heading = "<h3>".__('Options for Native Links')."</h3>";
            $tip ="<div class='tiplinks'><ul> " . $closer . "<li><input id='b1' type='button' value='1' class='pbutton p1 disable' disabled='disabled' /></li><li><input id='b2' type='button' value='2' class='pbutton p2' /></li></ul></div><div id='tippage1' class='tippage viewing'>" . $heading . $anchor_options . "</div><div id='tippage2' class='tippage' style='display:none;'>" . $heading . $menu_alias . $relnofollow . $do_not_use_option . "</div>";
            break;
        }

        case TYPE_ELINK: {
            $heading = "<h3>".__('Options for User URIs')."</h3>";
            $tip = "<div class='tiplinks'><ul>" . $closer . "<li><input id='b1' type='button' value='1' class='pbutton p1 disable' disabled='disabled' /></li>
<li><input id='b2' type='button' value='2' class='pbutton p2' /></li><li><input id='b3' type='button' value='3' class='pbutton p3' /></li></ul></div><div id='tippage1' class='tippage viewing'>" . $heading . $menu_alias . "<h4>".__('URI')."</h4><p>".__('Referring to these as \'external links\' may be a little misleading; this item can be used to add a navigation link to an \'off-site\' or \'on-site\' URI (')."<em>".__('Uniform Resource Identifier')."</em>".__('). Acceptable scheme syntax includes \'HTTP\', \'mailto\', \'FTP\', or page bookmarks (#).')."</p><p>".__('Typical usage would include identifying an link to a page, a link to a category or even a posting within your blog, a link to a location outside your blog, it can also be used to reference an internal target or bookmark on a page. For example,')."</p><p style='text-align:center; padding: 5px;'><em>http://your-website-address/about-you#section-name</em><p><p>".__('This syntax can be used to jump to a bookmark on a page.')."<p><em>".__('Mailto')."</em> ".__('syntax can be used to invoke the viewer\'s email program with various parts of the email message filled in. Examples include')."</p><ul><li>".__('email address with a subject: mailto:john@somepace.com?subject=I\'d like to order a pizza,<li>an email with a copy: mailto:john@someplace.com?cc=john@somewhere-else.com')."</li></ul><h4>".__('URI Options')."</h4><p>".__('These options are primarily used for a HTTP URI. A link can be opened in a new window or the same window by selecting the desired setting. The link relationship attribute \'rel\' can be set to \'follow\' or \'nofollow\'') ."</p></div><div id='tippage2' class='tippage' style='display:none;'>" . $heading . $anchor_options . "</div><div id='tippage3' class='tippage' style='display:none;'>" . $heading . $private_option . $do_not_use_option . "</div>";
            break;
        }

        case TYPE_AUTHOR: {
            $heading = "<h3>".__('Options for Blog User\'s')."</h3>";
            $tip = "<div class='tiplinks'><ul> " . $closer . "<li><input id='b1' type='button' value='1' class='pbutton p1 disable' disabled='disabled' /></li><li><input id='b2' type='button' value='2' class='pbutton p2' /></li></ul></div><div id='tippage1' class='tippage viewing'>" . $heading . "<h4>".__('Show Avatar')."</h3><p>".__('Display of the user avatar is controlled by this checkbox.')."</p><h4>".__('Use default')."</h4><p>".__('Checking this box indicates that the avatar is to come from one of the choices provided in the drop down control. You can add your own avatars to ths list by copying images into the NAVT avatar directory. Your avatar should be 32 pixels by 32 pixels in size and may be in one of the following formats: jpeg, jpg, bmp, png or gif. The selected avatar will be displayed in the small area provided above the selection.')."</p><h4>".__('Avatar URL')."</h4><p>".__('If are using an avatar and the <em>Use default</em> checkbox is not checked, this Avatar URL textbox enables you to specify a URI for an avatar. The URI must be a fully qualified path:<em>http://your-site.com/images/avatar.jpg.</em>')."</p><h4>".__('Append post count')."</h4><p>".__('Checking this box will append the number of posts the user has submitted to the user\'s link.')."</p><h4>".__('Show if no posts')."</h4><p>".__('By default, the user is not displayed if they have not created a post in the blog. Check this box if you want the user displayed if they have not created a posting.')."</p><h4>".__('Include...')."</h4><p>".__('Additional user information links may be added along with the user link by checking the boxes for email, website or the user\'s biographical summary. All of this information is obtained from the User\'s profile page on your blog. The various pieces of information can be styled and positioned independently.')."</p><h4>".__('Hide link text')."</h4><p>".__('All text associated with an author link can be hidden by selecting this checkbox. The checkbox is not available if you are not using an avatar.')."</p></div><div id='tippage2' class='tippage' style='display:none;'>" . $heading . $menu_alias . $relnofollow . $do_not_use_option . "<h4>".__('Example')."</h4><p>".__('The following is an example of two author anchors. ')."</p><ul><li>".__('The link connected with the avatar takes the viewer to the author\'s archive page.')."</li><li>".__('The link containing the name is a mailto URI with the user\'s email address.')."</li><li>".__('The Bio summary appears next.')."</li><li>".__('The bottom link is a link to the author\'s personal web site.')."</li></ul><div class='avex'><ul><li><a title='".__('Menu Alias')."' class='avlink' href='#'><img class='av' src='" . $avatar_url . "/avatar_male.gif' alt='".__('Male Avatar')."' /></a><div class='detail_wrapper'><a class='avemail' title='".__('mail comments to')."' href='mailto: jdoe@somewhere.com'>".__('John Doe')."</a><p class='avbio'>".__('This is a short bio statement')."</p><a class='avweb' title='".__('web site')."' href='http://somewhere.com'>".__('Doe Industries')."</a></div></li><li><a title='".__('Menu Alias')."' class='avlink' href='#'><img class='av' src='" . $avatar_url ."/avatar_female.gif' alt='".__('Female Avatar')."' /></a><div class='detail_wrapper'><a class='avemail' title='".__('mail comments to')."' href='mailto: msmith@somewhere.com'>".__('Mary Smith')."</a><p class='avbio'>".__('This is a short bio statement')."</p><a class='avweb' title='web site' href='http://somewhere.com'>".__('Mary\'s web site')."</a></div></li></ul></div></div>";
            break;
        }

        case TYPE_SEP: {
            $heading = "<h3>".__('Options for List Dividers')."</h3>";
            $tip = "<div class='tiplinks'><ul>" . $closer . "</ul></div><div id='tippage1' class='tippage'>" . $heading ."<p>".__('Dividers can be used for separating a single group of navigation items into two or more sub-groups by following these steps:')."</p><ol><li>".__('Place several items in a single navigation group')."</li><li>".__('Arrange related links close together')."</li><li>".__('Create and insert divider items at key locations to make sub-groups.')."</ol><h4>".__('Text (plain text option)')."</h4><p>".__('This textbox applies to only Plain Text style dividers. When using a Plain Text divider enter the plain text you want to appear before the group of list items. This textbox is not available when the divider type is set to anything other than Plain Text dividers.<h4>Divider Type</h4><p>There are three types of dividers:')."</p><dl><dt>".__('Empty Space')."</dt><dd> ".__('As the name implies this creates an empty space between groups.')."</dd><dt>".__('Horiztonal Rule')."</dt><dd>".__('This creates a horizontal rule between items using an HR tag ')."</dd><dt>".__('Plain Text')."</dt><dd>".__('A plain text divider is text encapsulated in a h3 tag. The H3 can be styled to appear as a navigation header title.')."</dd></dl><h4>".__('Usage Notes')."</h4><ul><li>".__('If you move a divider to the unassigned group, the item is not saved during an update since a divider has no meaning in the context of unassigned items')."</li><ul></div>";
            break;
        }
    }

    ob_start();
    header('Content-Type: text/html; charset: UTF-8');
    $expire_offset = 0;
    header('Expires: ' . gmdate('D, d M Y H:i:s', time() + $expire_offset) . ' GMT');
    printf("<div class='tipwin'>");
    printf("%s", $tip);
    printf("</div>");
    printf("
        <script type='text/javascript'>
        //<![CDATA[

            jQuery('.closer').click(function() {
                jQuery('#NT').fadeOut('slow', function(){jQuery(this).remove()})
            });

            jQuery('.p1').click(function() {return(set_page(1))});
            jQuery('.p2').click(function() {return(set_page(2))});
            jQuery('.p3').click(function() {return(set_page(3))});

            jQuery('.cbutton').hover(
                function() {jQuery(this).addClass('cb_in');},
                function() {jQuery(this).removeClass('cb_in');}
            );

            jQuery('.pbutton').hover(
                function() {jQuery(this).addClass('pb_in');},
                function() {jQuery(this).removeClass('pb_in');}
            );

            function set_page(p) {
                jQuery('.viewing').fadeOut('slow').removeClass('viewing');
                jQuery('#tippage' + p).fadeIn('slow').addClass('viewing');
                jQuery('#b' + p).attr('disabled', 'disabled').addClass('disable');
                jQuery('#b' + ((p == 1) ? '2': (p == 2) ? '1': '1')).removeAttr('disabled').removeClass('disable');
                jQuery('#b' + ((p == 1) ? '3': (p == 2) ? '3': '2')).removeAttr('disabled').removeClass('disable');
                return false;
            }
        //]]>
        </script>
        ");

    // send it
    ob_end_flush();
}
?>